import numpy as np

black, blue, red, green, yellow, grey, pink, orange, teal, maroon = range(10)

def main(input_grid: np.ndarray) -> np.ndarray:
    output_grid = np.copy(input_grid)
    green_block_found = False
    for i in range(len(input_grid)-1):
        for j in range(len(input_grid[0])-1):
            if input_grid[i][j] == green and input_grid[i][j+1] == green and input_grid[i+1][j] == green and input_grid[i+1][j+1] == green:
                green_block_found = True
                green_corners = [(i, j), (i, j+1), (i+1, j), (i+1, j+1)]
                for corner in green_corners:
                    row, col = corner
                    if input_grid[row][col] != black:
                        for k in range(col-1, -1, -1):
                            if input_grid[row][k] != black:
                                for l in range(k+1, col):
                                    if output_grid[row][l] == black:
                                        output_grid[row][l] = input_grid[row][k]
                                break
                        for k in range(col+1, len(input_grid[0])):
                            if input_grid[row][k] != black:
                                for l in range(col+1, k):
                                    if output_grid[row][l] == black:
                                        output_grid[row][l] = input_grid[row][k]
                                break
                        for k in range(row-1, -1, -1):
                            if input_grid[k][col] != black:
                                for l in range(k+1, row):
                                    if output_grid[l][col] == black:
                                        output_grid[l][col] = input_grid[k][col]
                                break
                        for k in range(row+1, len(input_grid)):
                            if input_grid[k][col] != black:
                                for l in range(row+1, k):
                                    if output_grid[l][col] == black:
                                        output_grid[l][col] = input_grid[k][col]
                                break
    if not green_block_found:
        return (-1, -1)
    return output_grid